var querystring = require('querystring');
var OAuth2 = require('oauth').OAuth2;
var token;

console.log("token:");
console.log(token);

var Client = function(oauth_config) {
  console.log(oauth_config);
  this.oauth2 = new OAuth2(
    oauth_config.consumer_key,
    oauth_config.consumer_secret,
    'https://api.yelp.com/',
    null,
    'oauth2/token',
    null
  );

  this.oauth2.getOAuthAccessToken(
    '',
    {
      'grant_type':'client_credentials'
    }, function (e, access_token, refresh_token, results){
      console.log("error");
      console.log(e);
      console.log('bearer: ', access_token);
      token = access_token;
      console.log("token is");
      console.log(token);
    });


  return this;
};

var base_url = "http://api.yelp.com/v3/";

Client.prototype.get = function(resource, params, callback) {
  console.log("resource");
  console.log(resource);
  console.log("params");
  console.log(params);
  return this.oauth2.get(
    base_url + resource + '?' + querystring.stringify(params),
    'Bearer ' + token,
    function(error, data, response) {
      console.log("error:");
      console.log(error);
      console.log("data:");
      console.log(data);
      console.log("response");
      console.log(response);
      // if(!error) data = JSON.parse(data);
      // callback(error, data, response);
    }
  );
}

/*
Example:
yelp.search({term: "food", location: "Montreal"}, function(error, data) {});
*/
Client.prototype.search = function(params, callback) {
  return this.get('businesses/search', params, callback);
}

/*
Example:
yelp.business("yelp-san-francisco", function(error, data) {});
*/
Client.prototype.business = function(id, callback) {
  return this.get('businesses/' + id, null, callback);
}

/*
 Example:
 yelp.business("yelp-san-francisco", function(error, data) {});
 */
Client.prototype.phone = function(params, callback) {
    return this.getV1('businesses/search/phone', params, callback);
}

// @see http://www.yelp.com/developers/documentation/v2/authentication
module.exports.createClient = function(oauth_config) {
  return new Client(oauth_config);
};
